//Magic Wand Driver V1.0A
//Boris van Galvin
#include <Servo.h>
#include <Bounce2.h>
//#define DEBUG

Servo esc;
Bounce debouncer = Bounce();

int throttlePin = A6;
int modePin = 10;
int escPin = 2;
int LEDPin = 13;
int mode = 0;
int rawSpeed = 0;
int escSpeed = 700;

long pulse = 200;
long lastPulse = 0;
int vibrate = 0;

int rampSpeed = 100;
int rampDir = 1;
int rampSteps = 10;
int rampDivisor = 10;

void setup() {
Serial.begin(9600);
pinMode(modePin,INPUT_PULLUP);
pinMode(LEDPin, OUTPUT);
esc.attach(escPin, 768, 2400);  // 1490 //650, 2250 full deflection. attaches the servo on pin 9 to the servo object
debouncer.attach(modePin);
debouncer.interval(450); // interval in ms

}

void loop() {
unsigned long currentMillis = millis();

  // Update the Bounce instance :
 debouncer.update();
if (debouncer.fell()) {
if (mode <= 2){
  mode++;
  }else{
  mode = 0;
  }
}
// read the POT
rawSpeed = analogRead(throttlePin);

switch(mode){
    case 0:
        escSpeed = 700;
        break;
  case 1:
        digitalWrite(LEDPin, 1);
        // standard vibrate
          if(rawSpeed >= 100){
          escSpeed = map(rawSpeed, 100, 1023, 1115, 1300);
        }else{
          escSpeed = 700;
        }
        break;
  case 2:
        // pulsate the vibration
        //pulseTime = currentMillis;
      if(rawSpeed >= 100){
        if(currentMillis - lastPulse >= pulse){
          lastPulse = currentMillis;
          if(vibrate == 0){
            digitalWrite(LEDPin, 1);
            escSpeed = map(rawSpeed, 100, 1023, 1150, 1400);
            vibrate = 1;
          }else{
            digitalWrite(LEDPin, 0);
            escSpeed = 1100;
            vibrate = 0;
          }    
        }
      }else{
        escSpeed = 700;
      }
        break;
  case 3:
        // Ramp speed up and down
        //escSpeed = map(rawSpeed, 100, 1023, 1150, 1400);

       if(rawSpeed >= 100){
         if(currentMillis - lastPulse >= 60){
          lastPulse = currentMillis;
          //Ramp Up and Down
          //Ramp Up      
          if(rampDir == 1){
            if(rampSpeed <= rawSpeed){
              rampSpeed = rampSpeed + (rawSpeed / rampDivisor);
              escSpeed = map(rampSpeed, 100, 1023, 1150, 1400);
              digitalWrite(LEDPin, 1);
            } else {
              rampDir = 0;
            }
          }
          //Ramp Down
          if(rampDir == 0){
            if(rampSpeed >= 100){
              rampSpeed = rampSpeed - (rawSpeed / rampDivisor);
              escSpeed = map(rampSpeed, 100, 1023, 1150, 1400);
              digitalWrite(LEDPin, 0);
            } else {
              rampDir = 1;
            }            
          }
         }
       }else{
        escSpeed = 700;        
       }
 //      escSpeed = map(rampSpeed, 100, 1023, 1150, 1400);
        break;
}


esc.writeMicroseconds(escSpeed);
#ifdef SWDEBUG
Serial.print("Mode: ");
Serial.print(mode);
Serial.print(" Raw Speed: ");
Serial.print(rawSpeed);
Serial.print(" Speed: ");
Serial.print(escSpeed);
Serial.print(" Ramp Speed: ");
Serial.print(rampSpeed);
Serial.print(" Direction: ");
Serial.println(rampDir);
#endif
}
